<?php

/**
 *
 * VM Payment - PayTR Virtual Pos iFrame API
 *
 * @author PayTR Ödeme Hizmetleri A.Ş.
 * @package VirtueMart
 * @subpackage payment
 * Copyright (C) 2021 PayTR Ödeme Hizmetleri A.Ş. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
 *
 * http://virtuemart.net
 */

defined('_JEXEC') or die();

/**
 * Class PaytrRequestHelper
 */
class PaytrRequestHelper
{

  private $variables;

    /**
     * PaytrRequestHelper constructor.
     * @param $variables
     */
  public function __construct($variables)
  {
    $this->variables = $variables;
  }

    /**
     * @return array
     */
  public function getPaytrToken()
  {
    $ch=curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://www.paytr.com/odeme/api/get-token");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POST, 1) ;
    curl_setopt($ch, CURLOPT_POSTFIELDS, $this->variables);
    curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
    curl_setopt($ch, CURLOPT_TIMEOUT, 20);
    $result = json_decode(curl_exec($ch));
    if($result->status === 'success'){
      return [
        'token' => $result->token
      ];
    }
    return [
      'error' => $result->reason
    ];
  }

    /**
     * @return mixed
     */
  public function doRefund()
  {
      $ch=curl_init();
      curl_setopt($ch, CURLOPT_URL, "https://www.paytr.com/odeme/iade");
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($ch, CURLOPT_POST, 1) ;
      curl_setopt($ch, CURLOPT_POSTFIELDS, $this->variables);
      curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
      curl_setopt($ch, CURLOPT_TIMEOUT, 90);
      curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 90);
      $result = @curl_exec($ch);
      if(curl_errno($ch))
      {
          echo curl_error($ch);
          curl_close($ch);
          exit;
      }
      curl_close($ch);
      return json_decode($result,1);
  }

}
